import os

from django.conf import settings
from django.template import Context, Template
from django.test import TestCase, RequestFactory

from django.core.urlresolvers import reverse
from django.contrib.sessions.backends.db import SessionStore

from evoteusers.tests.utils import UserTestUtils


project_path = settings.PROJECT_DIR


class TemplateTagsTest(UserTestUtils, TestCase):

    def render_template(self, string, context=None, request=None):
        context = context or {}
        context = Context(context)
        return Template(string).render(context)


class AmaTagsTest(TemplateTagsTest):
    """ """

    def setUp(self):
        self.login()
        self.factory = RequestFactory()

    def test_render_form(self):
        template = "{% load ama_tags %}{% show_autenticacaogov_login" + \
                   " '/test_url/' '/test_err_url/' " +\
                   "'' '2016-12-23T18:32:10Z'" +\
                   " 'evt967b594a768b0e3ca42eb51fbc2dc2fd07f673d8'" +\
                   " classes='unit' logo=False %}"
        testr_path = os.path.join(
            project_path, 'contrib/ama/tests/samlreqtest.txt')
        expected = open(testr_path).read()

        request = self.factory.get(reverse('ama:samlresponse'))
        s = SessionStore()
        s.create()
        s = SessionStore(session_key='DUMMYSESSKEY')
        request.session = s
        context = {'request': request}
        rendered = self.render_template(template, context)
        self.assertInHTML(expected, rendered)
