from django.test import SimpleTestCase
from django.utils import timezone

from evotevotings.voters.models import ElectoralRoll, ElectionVoter
from evotedocs.models import Document


class ElectoralRollTest(SimpleTestCase):
    """ """

    def test_str_equal_to_designation(self):
        document = Document(designation="designation")
        instance = ElectoralRoll(document=document)
        self.assertEqual(str(instance), instance.document.designation)


class ElectionVoterTest(SimpleTestCase):

    def test_str(self):
        ev_obj = ElectionVoter(personnel_number='30218', name='Dev Test')
        self.assertEqual(
            str(ev_obj),
            "{} ({})".format('Dev Test', '30218'))

    def test_is_vote_available(self):
        modified = timezone.now() - timezone.timedelta(days=1)
        ev_obj = ElectionVoter(vote_status=1, modified=modified)
        self.assertEqual(ev_obj.is_vote_available, (1, False))

    def test_is_pin_valid(self):
        ev_obj = ElectionVoter(pin_value='QWERTY')
        self.assertEqual(ev_obj.is_token_valid('WRONG'), False)

    def test_is_pin_valid_expiration_date(self):
        exp = timezone.now() - timezone.timedelta(days=1)
        ev_obj = ElectionVoter(pin_value='QWERTY', token_expiration_date=exp)
        self.assertEqual(ev_obj.is_token_valid('QWERTY'), False)
